"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function option(defaults = {}) {
    return (options) => {
        options = options || {};
        return Object.assign({ parse: (i) => i }, defaults, options, { input: [], multiple: !!options.multiple, type: 'option' });
    };
}
exports.option = option;
function boolean(options = {}) {
    return Object.assign({}, options, { allowNo: !!options.allowNo, type: 'boolean' });
}
exports.boolean = boolean;
exports.integer = option({
    parse: input => {
        if (!/^[0-9]+$/.test(input))
            throw new Error(`Expected an integer but received: ${input}`);
        return parseInt(input, 10);
    },
});
const stringFlag = option();
exports.string = stringFlag;
exports.defaultFlags = {
    color: boolean({ allowNo: true }),
};
