"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const deps_1 = require("./deps");
function dim(s) {
    if (deps_1.deps.chalk)
        return deps_1.deps.chalk.dim(s);
    return s;
}
function flagUsage(flag, options = {}) {
    const label = [];
    if (flag.char)
        label.push(`-${flag.char}`);
    if (flag.name)
        label.push(` --${flag.name}`);
    const usage = flag.type === 'option' ? ` ${flag.name.toUpperCase()}` : '';
    let description = flag.description || '';
    if (options.displayRequired && flag.required)
        description = `(required) ${description}`;
    description = description ? dim(description) : undefined;
    return [' ' + label.join(',').trim() + usage, description];
}
exports.flagUsage = flagUsage;
function flagUsages(flags, options = {}) {
    if (!flags.length)
        return [];
    const _ = require('ts-lodash').default;
    flags = _.sortBy(flags, f => [!f.char, f.char, f.name]);
    return flags.map(f => flagUsage(f, options));
}
exports.flagUsages = flagUsages;
